% TRIANGULACION DE DELAUNAY-3D 
%
% ENTRADA: Lectura o generacion de una generacion de puntos en 3D.
%            Aplicar la funcion proprocionada por Matlab para construir una triangulacion de Delaunay.    
%   
% SALIDA: Representar graficamente la malla resultante
syms('AA', 'NAME', 'INP', 'OK', 'N', 'I', 'J', 'A');
TRUE =1;
FALSE=0;
N=0;
fprintf(1,'Este es el Metodo de Triangulacion de Delaunay-3D.\n');
fprintf(1,'1. Entrada de datos por fichero\n');
fprintf(1,'2. Generacin de puntos de forma aleatoria\n');
fprintf(1,'Escriba 1 o 2:\n');
AA = input(' ');
if AA == 1
    fprintf(1,'Escriba el nombre del fichero de la forma - disco:\\nombre.ext\n');
    fprintf(1,'Introduce en el fichero la terna de valores de cada punto, punto por fila.\n');
    fprintf(1,'por ejemplo:   A:\\DATA.DTA\n');
    NAME = input(' ','s');
    INP = fopen(NAME,'rt');
    OK = TRUE;
    A = [];
    while OK == TRUE 
        for I = 1 : 3
            B = fscanf(INP, '%f',3);
            if min(size(B)) == 0
                OK = FALSE;
                break;
            end;
            A=[A;B'];
            N=N+1;
        end;
    end;
    AA = input('Desea escalar?. (Y o N)','s');
    if AA == 'Y' || AA == 'y'
        AA = input('Introduzca los factores de escala en lineas separadas. (nx ny nz)\n');
        A(:,1)=A(:,1).*AA;
        AA = input(' ');
        A(:,2)=A(:,2).*AA;
        AA = input(' ');
        A(:,3)=A(:,3).*AA;
    end;
else
    fprintf(1,'Escriba el nmero de puntos: \n');
    AA = input(' ');
    N=AA;
    A = rand(AA,3);
    AA = input('Introduzca los factores de escala en lineas separadas. (nx ny nz)\n');
    A(:,1)=A(:,1).*AA;
    AA = input(' ');
    A(:,2)=A(:,2).*AA;
    AA = input(' ');
    A(:,3)=A(:,3).*AA;    
end;



    min_X=min(A(:,1));
    max_X=max(A(:,1));
    min_Y=min(A(:,2));
    max_Y=max(A(:,2));
    min_Z=min(A(:,3));
    max_Z=max(A(:,3));
    d_X=[min_X, max_X];
    d_Y=[min_Y, max_Y];
    d_Z=[min_Z, max_Z];
    
    fprintf(1,'1. Considerar un cubo que encierra los puntos\n');
    fprintf(1,'2. NO Considerar un cubo que encierra los puntos\n');
    fprintf(1,'Escriba 1 o 2:\n');
    AA = input(' ');
    colormap('colorcube');
    if AA == 1    
        [x,y,z] = meshgrid(d_X,d_Y,d_Z);
        x = [x(:);A(:,1)];
        y = [y(:);A(:,2)];
        z = [z(:);A(:,3)];
        Tes = delaunay3(x,y,z);
        X = [x(:) y(:) z(:)];
        tetramesh(Tes,X);camorbit(20,0)
    else
        x = [A(:,1)];
        y = [A(:,2)];
        z = [A(:,3)];
        Tes = delaunay3(x,y,z);
        X = [x(:) y(:) z(:)];
        tetramesh(Tes,X);camorbit(20,0)
    end;
        
        

    fprintf(1,'1. Desea guardar los puntos en un fichero??\n');
    fprintf(1,'2. Terminar\n');
    fprintf(1,'Escriba 1 o 2:\n');
    AA = input(' ');
    if AA == 1
        fprintf(1,'Escriba el nombre del fichero de la forma - disco:\\nombre.ext\n');
        fprintf(1,'por ejemplo:   A:\\DATA.DTA\n');
        NAME = input(' ','s');
        OUP = fopen(NAME,'wt');
        for I = 1 : N 
            for J = 1 : 3 
                fprintf(OUP, '  %f', A(I,J));
            end;
            fprintf(OUP, '\n');
        end;
 
        fclose(OUP);
        fprintf(1,'Fichero de salida %s creado con exito \n',NAME);
    end;




